Attribute VB_Name = "1"
Option Explicit
Public Declare Function GetWindowDC Lib "user32" (ByVal hWnd As Long) As Long ' 
Public Declare Function GetForegroundWindow Lib "user32" () As Long '   
Public Declare Function GetClientRect Lib "user32" (ByVal hWnd As Long, _
       lpRect As RECT) As Long '    ()       
Public Declare Function GetDesktopWindow Lib "user32" () As Long '  
Public Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, _
ByVal nIndex As Long) As Long '         
Public Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) _
As Long '        
Public Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, _
       ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, _
       ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long '  
Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, _
       ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, _
       ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Public Declare Function StretchBlt Lib "gdi32.dll" (ByVal hdc As Long, _
       ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, _
       ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, _
       ByVal hSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long '  
Public Declare Function GetPixel Lib "gdi32.dll" (ByVal hdc As Long, _
       ByVal nXPos As Long, ByVal nYPos As Long) As Long '  
Public Declare Function SetPixel Lib "gdi32.dll" (ByVal hdc As Long, _
       ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long '  
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (lpvDest As Any, _
       lpvSource As Any, ByVal cbCopy As Long) '   
Public Declare Function GetObjectAPI Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, _
       ByVal nCount As Long, lpObject As Any) As Long ' 
Public Declare Function GetDIBits Lib "gdi32" (ByVal aHDC As Long, _
       ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, _
       lpBits As Any, lpBI As Any, ByVal wUsage As Long) As Long '   
Public Declare Function SetDIBitsToDevice Lib "gdi32" (ByVal hdc As Long, _
       ByVal X As Long, ByVal Y As Long, ByVal dX As Long, ByVal dY As Long, _
       ByVal SrcX As Long, ByVal SrcY As Long, ByVal Scan As Long, _
       ByVal NumScans As Long, Bits As Any, BitsInfo As Any, ByVal wUsage As Long) As Long '   

Public Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Public Type RGBQUAD
     rgbBlue As Byte
     rgbGreen As Byte
     rgbRed As Byte
     rgbReserved As Byte
End Type

Public Type BITMAPINFOHEADER
     biSize As Long
     biWidth As Long
     biHeight As Long
     biPlanes As Integer
     biBitCount As Integer
     biCompression As Long
     biSizeImage As Long
     biXPelsPerMeter As Long
     biYPelsPerMeter As Long
     biClrUsed As Long
     biClrImportant As Long
End Type

Public Type BITMAPINFO
    bmiHeader As BITMAPINFOHEADER
    bmiColors() As RGBQUAD
End Type

Public Type BITMAP
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
End Type

Private Type DOUBLERGB
   B1 As Byte
   G1 As Byte
   R1 As Byte
   B2 As Byte
   G2 As Byte
   R2 As Byte
End Type

Public Const SRCCOPY = &HCC0020 '    ( = ).
Public Const NOTSRCCOPY = &H330008
Public Const PATCOPY = &HF00021
Public Const MERGECOPY = &HC000CA
Public Const SRCAND = &H8800C6  '     (  And ).
Public Const SRCERASE = &H440328 ' And      ( =  And ( ).
Public Const NOTSRCERASE = &H1100A6
Public Const SRCINVERT = &H660046 ' Xor    ( =  Xor ).
Public Const PATINVERT = &H5A0049
Public Const DSTINVERT = &H550009
Public Const SRCPAINT = &HEE0086  ' Or     ( =  Or ).
Public Const PATPAINT = &HFB0A09
Public Const MERGEPAINT = &HBB0226
Public Const WHITENESS = &HFF0062
Public Const BLACKNESS = &H42
' Const CAPTUREBLT = ???
' Const NOMIRRORBITMAP = ???
Public Const HORZSIZE = 4 '   
Public Const VERTSIZE = 6 '   
Public Const HORZRES = 8 '    
Public Const VERTRES = 10 '   
Public Const LOGPIXELSX = 88 '-       
Public Const LOGPIXELSY = 90 '-       
Public Const SM_CXFULLSCREEN = 16 '    
Public Const SM_CYFULLSCREEN = 17 '    

Public Const HWND_NOTOPMOST = -2
Public Const HWND_TOPMOST = -1 '    
Public Const SWP_NOACTIVATE = &H10
Public Const SWP_NOMOVE = &H2
Public Const SWP_NOSIZE = &H1
    
Public Const BI_RGB = 0&
Public Const DIB_RGB_COLORS = 0

Public i&, j&, Info$, Rezult& ' 
Public H1&, W1&, H2&, W2&, H1mm&, W1mm& '         
Public DataPic() As Byte '       
Public Deskriptor& '            
Public BI As BITMAPINFO '      BITMAPINFO
Public TempPic As PictureBox '  PictureBox
Public rct As RECT '         (   )
Public Metod& '                 
Public MX!, MY!, dX!, dY! '         
Public i1!, j1!, im&, jm&, ip&, jp& '      VB
Public oldR&(), oldG&(), oldB&(), newR&(), newG&(), newB&() '      VB 
Public oldCvet&(), newCvet&() '                    VB 
Public R10!, G10!, B10!, R20!, G20!, B20! '      API 
Public Random!, KR%, KG%, KB% '        

Public Sub MCopyAPI(ByVal oldPicture As Object) '      MCopy  API
Dim iBite&, R&, G&, B& '                                                       
Dim Verh As DOUBLERGB, Niz As DOUBLERGB, newData() As Byte, bmp As BITMAP '    
Dim R11!, R12!, R21!, R22!, G11!, G12!, G21!, G22!, B11!, B12!, B21!, B22! '    
Set TempPic = frmTemp.picMain
TempPic.Picture = oldPicture
Call GetObjectAPI(TempPic.Picture, Len(bmp), bmp)
ReDim BI.bmiColors(0)
   With BI.bmiHeader
       .biSize = Len(BI.bmiHeader)
       .biWidth = bmp.bmWidth
       .biHeight = bmp.bmHeight
       .biPlanes = 1
       .biBitCount = 24
       .biCompression = BI_RGB
       .biSizeImage = BytesPerScanLine(.biWidth) * .biHeight
       ReDim DataPic(BytesPerScanLine(.biWidth) - 1, .biHeight - 1)
   End With
Rezult = GetDIBits(TempPic.hdc, TempPic.Picture, 0, BI.bmiHeader.biHeight, _
         DataPic(0, 0), BI, DIB_RGB_COLORS)
TempPic.Width = W2
TempPic.Height = H2
ReDim newData(BytesPerScanLine(W2) - 1, H2 - 1)
MX = UBound(DataPic, 1) / 3 / W2: MY = UBound(DataPic, 2) / H2 '  
For j = 0 To H2 - 1 '      ,  
    j1 = j * MY: jm = Int(j1): dY = j1 - jm: jp = jm + 1 '  
For i = 0 To W2 - 1 ' Int      
    i1 = i * MX: im = Int(i1): dX = i1 - im: im = im * 3 '   Fix
      CopyMemory Verh, DataPic(im, jm), 6 '   XY VB
      CopyMemory Niz, DataPic(im, jp), 6 'Int(2.4)=2, Int(2.6)=3, Fix(2.4)=2, Fix(2.6)=2
      R11 = Verh.R1: R12 = Verh.R2: R21 = Niz.R1: R22 = Niz.R2 '   2-
      G11 = Verh.G1: G12 = Verh.G2: G21 = Niz.G1: G22 = Niz.G2 '   2- 
      B11 = Verh.B1: B12 = Verh.B2: B21 = Niz.B1: B22 = Niz.B2 ' 
      
      R10 = KR * R11 * (1 - dY) / 100 + KR * R21 * dY / 100 '  
      G10 = KG * G11 * (1 - dY) / 100 + KG * G21 * dY / 100 '  
      B10 = KB * B11 * (1 - dY) / 100 + KB * B21 * dY / 100 ' 2   2  
      R20 = KR * R12 * (1 - dY) / 100 + KR * R22 * dY / 100
      G20 = KG * G12 * (1 - dY) / 100 + KG * G22 * dY / 100
      B20 = KB * B12 * (1 - dY) / 100 + KB * B22 * dY / 100
      
B = (B10 * (1 - dX) + B20 * dX) * (1 + (Random - 2 * Random * Rnd(dX)) / 100)
If B > 255 Then B = 255 '       2
G = (G10 * (1 - dX) + G20 * dX) * (1 + (Random - 2 * Random * Rnd(dX)) / 100)
If G > 255 Then G = 255 '   
R = (R10 * (1 - dX) + R20 * dX) * (1 + (Random - 2 * Random * Rnd(dX)) / 100)
If R > 255 Then R = 255
iBite = i * 3
newData(iBite, j) = B: newData(iBite + 1, j) = G: newData(iBite + 2, j) = R
Next i
Form1.Caption = "    " & W2 & " * " & _
H2 & "            " & Fix(j * 100 / (H2 - 1)) & "  "
Next j
ReDim DataPic(BytesPerScanLine(W2) - 1, H2 - 1)
CopyMemory DataPic(0, 0), newData(0, 0), BytesPerScanLine(W2) * H2 '    
       With BI.bmiHeader '                                            
           .biWidth = W2
           .biHeight = H2
           .biSizeImage = BytesPerScanLine(.biWidth) * .biHeight
       End With
TempPic.Picture = LoadPicture()
Rezult = SetDIBitsToDevice(TempPic.hdc, 0, 0, BI.bmiHeader.biWidth, _
BI.bmiHeader.biHeight, 0, 0, 0, BI.bmiHeader.biHeight, DataPic(0, 0), BI, DIB_RGB_COLORS)
TempPic.Refresh

Form1.picMain.Height = H2 '   
Form1.picMain.Width = W2
Form1.vsbScroll.Max = H2 '     
Form1.hsbScroll.Max = W2 '         ,   
'Form1.picMain.Cls '                     
'Form1.picMain.Picture = LoadPicture() '   
Rezult = StretchBlt(Form1.picMain.hdc, 0, 0, W2, H2, TempPic.hdc, 0, 0, W2, H2, Metod) '  API
'Form1.picMain.PaintPicture TempPic.Image, 0, 0, W2, H2, 0, 0, W2, H2, Metod'             VB
'Form1.picMain.Picture = TempPic.Image'                                   
Set TempPic = Nothing
End Sub

Public Function BytesPerScanLine(ByVal lWidth As Long) As Long '     
    BytesPerScanLine = (lWidth * 3 + 3) And &HFFFFFFFC
End Function

